<?php if (!defined('PmWiki')) exit();

/*	=== Bloge: Blog.NewPost customizations ===
 *	Copyright 2009 Eemeli Aro <eemeli@gmail.com>
 *
 *	This is a part of the Bloge bundle of recipes.
 *	For more information, please see the online documentation at
 *		http://www.pmwiki.org/wiki/Cookbook/Bloge
 */

if ($action=='browse') Redirect("$pagename?action=edit");

if ($action!='edit') return;

$ea_pos = array_search('EditAttrBeforePost',$EditFunctions);
array_splice($EditFunctions, ($ea_pos===FALSE) ? 0 : $ea_pos+1, 0, 'BlogeNewPost');
function BlogeNewPost($pagename, &$page, &$new) {
	global $EnablePost, $EditFunctions, $IsPagePosted, $Now, $Bloge;
	if (!$EnablePost) return;
	if (empty($new['ctime'])) $new['ctime'] = $Now;
	$pn = BlogeMakePageName($pagename, $new['ctime'], @$new['title']);
	if (PageExists($pn)) {
		$i = 1;
		$ls = ListPages("/^$pn-\d+$/");
		if (!empty($ls)) foreach ( $ls as $px ) $i = max($i, substr( $px, strrpos($px,'-')+1 ));
		$pn = MakePageName($pagename, $pn.'-'.($i+1));
	}
	$p = array_search('BlogeNewPost',$EditFunctions);
	if ($p!==FALSE)	unset($EditFunctions[$p]);
	UpdatePage($pn, $page, $new);
	$EnablePost = FALSE;
	Lock(0);
	if ($IsPagePosted) Redirect($pn);
}

function BlogeMakePageName($pagename, $time, $title) {
	global $PageNameChars, $MakePageNamePatterns, $now, $Bloge;

	SDV($PageNameChars,'-[:alnum:]');
	SDV($MakePageNamePatterns, array(
		"/'/" => '',			   # strip single-quotes
		"/[^$PageNameChars]+/" => ' ',         # convert everything else to space
		'/((^|[^-\\w])\\w)/e' => "strtoupper('$1')",
		'/ /' => ''));

	$pnpat = $MakePageNamePatterns;
	unset($pnpat['/ /']);
	$pnpat['/((^|[^-\\w])\\w)/e'] = "strtolower('-$1')";
	$pnpat['/[ -]+/'] = '-';
	$pnpat['/-$/'] = '';

	if (empty($time)) $time = $Now;

    $pn = $Bloge['group'] . '.'
		. strftime('%Y-%m-%d', $time)
		. preg_replace(array_keys($pnpat), array_values($pnpat), $title);
	return MakePageName($pagename, $pn);
}
